<?php

/**
 * Affiche du contenu dans des onglets
 *
 * suite description
 *
 * syntaxe {up slider_content }
 *
 * @author   LOMART
 * @version  1.0
 * @license   <a href="http://www.gnu.org/licenses/gpl-3.0.html" target="_blank">GNU/GPLv3</a>
 * @credit    <a href="https://www.jqueryscript.net/slider/Responsive-jQuery-Content-slider-with-HTML5-Liquid%20Slider.html" target"_blank">script Liquid Slider de KevinBatdorf</a>
 *
 */
defined('_JEXEC') or die;

class slider_content extends upAction {

    /**
     * charger les ressources communes à toutes les instances de l'action
     * cette fonction n'est lancée qu'une fois pour la première instance
     * @return true
     */
    function init() {
        $this->load_file('css/liquid-slider.css');
        $this->load_file('js/jquery.liquid-slider.min.js');
        $this->load_file('js/jquery.touchSwipe.min.js');
        $this->load_file('js/jquery.easing.1.3.js');
//        JHtml::_('stylesheet', 'https://cdnjs.cloudflare.com/ajax/libs/animate.css/3.0.0/animate.min.css');
        if (file_exists($this->actionPath . 'custom.css')) {
            $this->load_file('custom.css');
        }
        return true;
    }

    /**
     * analyse et interprete le shortcode
     * @return [string] [code HTML pour remplacer le shortcode]
     */
    function run() {

        // si cette action a obligatoirement du contenu
        if (!$this->ctrl_content_exists()) {
            return false;
        }

        // lien vers la page de demo
        // - vide = page sur le site de UP
        // - URL complete = page disponible sur ce lien
        // - rien pour ne pas proposer d'aide
        $this->set_demopage();

        // ===== valeur paramétres par défaut (sauf JS)
        $options_def = array(
          __class__ => '', // le paramétre principal
          'id' => '', // id genérée automatiquement par UP
          'class' => '', // classe(s) ajoutées au bloc principal
          'style' => ''    // style inline ajouté au bloc principal
        );

        // ===== paramétres attendus par le script JS
        // important: valeurs par défaut entre guillemets pour les chaines
        // attention: le nom des options est transmis au script sous la forme indiqué ici.
        $js_options_def = array(
          'autoHeight' => true,
          'autoSlide' => false,
          'autoSlideInterval' => 7000,
          'dynamicTabs' => true,
          'dynamictabsposition' => 'top'
        );

        // fusion et controle des options
        $options = $this->ctrl_options($options_def, $js_options_def);
        dump($options);
        // =========== le code JS
        // les options saisies par l'utilisateur concernant le script JS
        // cela évite de toutes les renvoyer au script JS
        $js_options = $this->only_using_options($js_options_def);

        // -- conversion en chaine Json
        // il existe 2 modes: mode1=normal, mode2=sans guillemets
        $js_params = $this->json_arrtostr($js_options);

        // -- initialisation
        $js_code = '$("#' . $options['id'] . '").liquidSlider(';
        $js_code .= $js_params;
        $js_code .= ');';
        $this->load_jquery_code($js_code);

        // === le code HTML
        // -- ajout options utilisateur dans la div principale
        $outer_div['id'] = $options['id'];
        $outer_div['class'] = $options['class'];
        $this->add_class($outer_div['class'], 'liquid-slider');
        $outer_div['style'] = $options['style'];

        // -- le code en retour
        $out = $this->set_attr_tag('div', $outer_div);
        $out .= $this->content;  // le contenu entre les shortcodes ouvrant et fermant
        $out .= '</div>';

        return $out;
    }

// run
}

// class
